openerp.account_bank_statement_voucher_import = function (instance, local) {
    local.widgetInstance = null;
    local.parentInstance = null;

    local.VoucherImportWidget = instance.Widget.extend({
        template: 'account_bank_statement_voucher_import.VoucherImport',
        id : undefined,
        voucherImport : [],
        statementLine: [],
        accountVoucher: [],
        statement: [],

        init: function (parent) {
            this._super(parent);
        },
        // Actualizar id del Objeto
        updateId : function(id){
            var self = this;
            self.id=id;
        },
        start: function () {
            var self = this;
            this.$el.click(function (e){
                self.fetchInitial();
            });
        },
        // Iniciar
        fetchInitial: function(){
            var self= this;
            self.fetchBankStatementLine().then(function(statementLine){
                return statementLine;
            }).then(function(statementLine){
                self.statementLine = statementLine;
                return self.fetchBankStatement();      
            }).then(function(statement){
                self.statement = statement;
                return self.fetchAcVoucher();
            }).then(function(accountVoucher){
                self.accountVoucher = accountVoucher;
                return self.fetchJoinVoucher();
            }).then(function(voucherImport){
                self.voucherImport = voucherImport;
                return self.insertBankStatementLine();
            }).then(function(bankLine){
                local.parentInstance.reload();
                if (bankLine){
                    instance.web.notification.do_notify("Felicitaciones", "Los pagos han sido importados con éxito.");
                }else{
                    instance.web.notification.do_warn("Atención ","No hay pagos para ser importados.");
                }
            });
        },

        // linea de Caja
        fetchBankStatementLine : function(){
            var self = this;
            var defer = $.Deferred();

            var fields=['id','ref','name','statement_id'];
            var domain=[['statement_id','=',self.id]];

            var statementLine = new instance.web.Model('account.bank.statement.line');

            statementLine.query(fields).filter(domain).all().then(function (results){
                defer.resolve(results);
            });
            return defer;
        },

        // Caja
        fetchBankStatement : function(){
            var self = this;
            var defer = $.Deferred();

            var fields=['id','journal_id'];
            var domain=[['id','=',self.id]];

            var statement = new instance.web.Model('account.bank.statement');

            statement.query(fields).filter(domain).all().then(function (results){
                defer.resolve(results);
            });
            return defer;
        },

        // consultar pagos
        fetchAcVoucher : function(){
            var self = this;
            var defer =$.Deferred();

            var name = _.flatten(_.map(self.statementLine,function(map){
                return map.name;
            }));
            var journal_id = _.flatten(_.map(self.statement,function(map){
                return map.journal_id[0];
            }));
            var fields =['id','reference','partner_id','state','amount','journal_id','type','bank_statement_line_ids','move_id','account_id'];
            var domain =[['state','=','posted'],['reference','not in',name],['bank_statement_line_ids', '=', false],['journal_id','=',journal_id]];
            var accountVoucher = new instance.web.Model('account.voucher');

            accountVoucher.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        
        // Generar Objeto principal
        fetchJoinVoucher:function(){
            var self = this;
            var defer = $.Deferred();
            var voucherImport=[];
            var journal;
            for (var i = 0; i < self.accountVoucher.length; i++) {
                voucher = self.accountVoucher[i];
                if(voucher.type=='receipt'){
                    voucherImport.push({
                        name : voucher.reference,
                        amount : voucher.amount,
                        type : voucher.type,
                        partner_id : voucher.partner_id[0],
                        account_id : voucher.account_id[0],
                        statement_id: this.id,
                        ref : voucher.name,
                        voucher_id : voucher.id,
                        journal_entry_id : voucher.move_id[0] 
                    });
                } else {
                    voucherImport.push({
                        name : voucher.reference,
                        amount : voucher.amount*-1,
                        type : voucher.type,
                        partner_id : voucher.partner_id[0],
                        account_id : voucher.account_id[0],
                        statement_id: this.id,
                        ref : voucher.name,
                        voucher_id : voucher.id,
                        journal_entry_id : voucher.move_id[0]
                    }); 
                }         
            }
            defer.resolve(voucherImport);
            return defer;
        },

        // insertar la Linea

        insertBankStatementLine : function(){
            var self =this;
            var defer = $.Deferred();
            var accountBanckStatementLine = new instance.web.Model('account.bank.statement.line');

            self.asyncLoopFactory(self.voucherImport.length, function (loop) {
                var objeto = self.voucherImport[loop.iteration()];

                accountBanckStatementLine.call('create',[objeto], {
                    context: new instance.web.CompoundContext()
                }).then(function (results) {
                    loop.next();
                });
            }, function () {
                defer.resolve(self.voucherImport.length);
            });

            return defer;
        },
        /* ---------------------------------------------------------------------
        * Description: Async loop util v2 written by Robert Gauto.
        * --------------------------------------------------------------------*/
        asyncLoopFactory : function (iterations, func, callback) {
            var index = 0;
            var done = false;
            var loop = {
                next: function () {
                    if (done) {
                        return;
                    }

                    if (index < iterations) {
                        index++;
                        func(loop);

                    } else {
                        done = true;
                        callback();
                    }
                },

                iteration: function () {
                    return index - 1;
                },

                break: function () {
                    done = true;
                    callback();
                }
            };

            loop.next();
            return loop;
        },

    });

if (instance.web && instance.web.FormView) {
    instance.web.FormView.include({
        load_record: function (record) {
            this._super.apply(this, arguments);

            if (this.model !== 'account.bank.statement') return;

            local.parentInstance = this;

            if (local.widgetInstance) {
                local.widgetInstance.updateId(record.id);
            }

            if (this.$el.find('.import_voucher').length != 0) return;

            local.widgetInstance = new local.VoucherImportWidget(this);

            var elemento = this.$el.find('.oe_form_sheet.oe_form_sheet_width');
            elemento =  elemento.find('.oe_right.oe_button_box.voucher_import');

            local.widgetInstance.appendTo(elemento);
            local.widgetInstance.updateId(record.id);
        }
    });
}

}
